<?php

/**
 * Created by PhpStorm.
 * User: tandunzhao
 * Date: 2017/12/4
 * Time: 下午1:43
 */

namespace General\Services\Config;

use App\Consts\SysConsts;
use General\Models\Config\CompanyAuthConfig;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Redis;

class ConfigService
{
    /**
     * 授权信息
     */
    public function findCompanyAuthConfig(string $app_id)
    {
        return CompanyAuthConfig::where('app_id', $app_id)->first();
    }

    /**
     * 授权ip列表
     * @return array
     */
    public function CompanyAuthIps(string $app_id)
    {
        $key = 'company_auth_ips_' . $app_id;
        if (Redis::exists($key)) {
            $ips = Redis::get($key);
        } else {
            $config = $this->findCompanyAuthConfig($app_id);
            if ($config) {
                $ips = $config->ip_list;
                Redis::setex($key, SysConsts::ONE_DAY_SECONDS, $ips);
            } else {
                return array();
            }
        }
        return explode(';', $ips);
    }

    public function findCompanyChannelIds($company_id) {
        $channel_user_ids = DB::connection('mysql')->table('channel_users')->where('company_id', $company_id)->pluck('id')->all();
        return DB::connection('mysql')->table('distribution_channels')->whereIn('channel_user_id', $channel_user_ids)->pluck('id')->all();
    }
}
